from dataiku import insights
import plotly.graph_objects as go
import plotly.express as px

def create_indicator(value,text,font_size,insight_name,unit=""):
    fig = go.Figure()

    fig.add_trace(go.Indicator(
        mode = "number",
        value = value,
        number = {'suffix': " " + str(unit)},
        title = {"text": text}
    ))

    fig.update_traces(number_font_size=font_size)
    insights.save_plotly(insight_name, fig)